bpf: Support pre-2.25-binutils objcopy for vmlinux BTF
[muen/linux.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # link vmlinux
5 #
6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10 # (not within --whole-archive), and do not require symbol indexes added.
11 #
12 # vmlinux
13 #   ^
14 #   |
15 #   +--< $(KBUILD_VMLINUX_OBJS)
16 #   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17 #   |
18 #   +--< $(KBUILD_VMLINUX_LIBS)
19 #   |    +--< lib/lib.a + more
20 #   |
21 #   +-< ${kallsymso} (see description in KALLSYMS section)
22 #
23 # vmlinux version (uname -v) cannot be updated during normal
24 # descending-into-subdirs phase since we do not yet know if we need to
25 # update vmlinux.
26 # Therefore this step is delayed until just before final link of vmlinux.
27 #
28 # System.map is generated to document addresses of all kernel symbols
29
30 # Error out on error
31 set -e
32
33 # Nice output in kbuild format
34 # Will be supressed by "make -s"
35 info()
36 {
37         if [ "${quiet}" != "silent_" ]; then
38                 printf "  %-7s %s\n" "${1}" "${2}"
39         fi
40 }
41
42 # Link of vmlinux.o used for section mismatch analysis
43 # ${1} output file
44 modpost_link()
45 {
46         local objects
47
48         objects="--whole-archive                                \
49                 ${KBUILD_VMLINUX_OBJS}                          \
50                 --no-whole-archive                              \
51                 --start-group                                   \
52                 ${KBUILD_VMLINUX_LIBS}                          \
53                 --end-group"
54
55         ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
56 }
57
58 # Link of vmlinux
59 # ${1} - output file
60 # ${2}, ${3}, ... - optional extra .o files
61 vmlinux_link()
62 {
63         local lds="${objtree}/${KBUILD_LDS}"
64         local output=${1}
65         local objects
66
67         info LD ${output}
68
69         # skip output file argument
70         shift
71
72         if [ "${SRCARCH}" != "um" ]; then
73                 objects="--whole-archive                        \
74                         ${KBUILD_VMLINUX_OBJS}                  \
75                         --no-whole-archive                      \
76                         --start-group                           \
77                         ${KBUILD_VMLINUX_LIBS}                  \
78                         --end-group                             \
79                         ${@}"
80
81                 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}      \
82                         -o ${output}                            \
83                         -T ${lds} ${objects}
84         else
85                 objects="-Wl,--whole-archive                    \
86                         ${KBUILD_VMLINUX_OBJS}                  \
87                         -Wl,--no-whole-archive                  \
88                         -Wl,--start-group                       \
89                         ${KBUILD_VMLINUX_LIBS}                  \
90                         -Wl,--end-group                         \
91                         ${@}"
92
93                 ${CC} ${CFLAGS_vmlinux}                         \
94                         -o ${output}                            \
95                         -Wl,-T,${lds}                           \
96                         ${objects}                              \
97                         -lutil -lrt -lpthread
98                 rm -f linux
99         fi
100 }
101
102 # generate .BTF typeinfo from DWARF debuginfo
103 # ${1} - vmlinux image
104 # ${2} - file to dump raw BTF data into
105 gen_btf()
106 {
107         local pahole_ver
108         local bin_arch
109
110         if ! [ -x "$(command -v ${PAHOLE})" ]; then
111                 info "BTF" "${1}: pahole (${PAHOLE}) is not available"
112                 return 1
113         fi
114
115         pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
116         if [ "${pahole_ver}" -lt "113" ]; then
117                 info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
118                 return 1
119         fi
120
121         info "BTF" ${2}
122         vmlinux_link ${1}
123         LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
124
125         # dump .BTF section into raw binary file to link with final vmlinux
126         bin_arch=$(LANG=C ${OBJDUMP} -f ${1} | grep architecture | \
127                 cut -d, -f1 | cut -d' ' -f2)
128         bin_format=$(LANG=C ${OBJDUMP} -f ${1} | grep 'file format' | \
129                 awk '{print $4}')
130         ${OBJCOPY} --set-section-flags .BTF=alloc -O binary \
131                 --only-section=.BTF ${1} .btf.vmlinux.bin 2>/dev/null
132         ${OBJCOPY} -I binary -O ${bin_format} -B ${bin_arch} \
133                 --rename-section .data=.BTF .btf.vmlinux.bin ${2}
134 }
135
136 # Create ${2} .o file with all symbols from the ${1} object file
137 kallsyms()
138 {
139         info KSYM ${2}
140         local kallsymopt;
141
142         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
143                 kallsymopt="${kallsymopt} --all-symbols"
144         fi
145
146         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
147                 kallsymopt="${kallsymopt} --absolute-percpu"
148         fi
149
150         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
151                 kallsymopt="${kallsymopt} --base-relative"
152         fi
153
154         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
155                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
156
157         local afile="`basename ${2} .o`.S"
158
159         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
160         ${CC} ${aflags} -c -o ${2} ${afile}
161 }
162
163 # Perform one step in kallsyms generation, including temporary linking of
164 # vmlinux.
165 kallsyms_step()
166 {
167         kallsymso_prev=${kallsymso}
168         kallsymso=.tmp_kallsyms${1}.o
169         kallsyms_vmlinux=.tmp_vmlinux${1}
170
171         vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
172         kallsyms ${kallsyms_vmlinux} ${kallsymso}
173 }
174
175 # Create map file with all symbols from ${1}
176 # See mksymap for additional details
177 mksysmap()
178 {
179         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
180 }
181
182 sortextable()
183 {
184         ${objtree}/scripts/sortextable ${1}
185 }
186
187 # Delete output files in case of error
188 cleanup()
189 {
190         rm -f .btf.*
191         rm -f .tmp_System.map
192         rm -f .tmp_kallsyms*
193         rm -f .tmp_vmlinux*
194         rm -f System.map
195         rm -f vmlinux
196         rm -f vmlinux.o
197 }
198
199 on_exit()
200 {
201         if [ $? -ne 0 ]; then
202                 cleanup
203         fi
204 }
205 trap on_exit EXIT
206
207 on_signals()
208 {
209         exit 1
210 }
211 trap on_signals HUP INT QUIT TERM
212
213 #
214 #
215 # Use "make V=1" to debug this script
216 case "${KBUILD_VERBOSE}" in
217 *1*)
218         set -x
219         ;;
220 esac
221
222 if [ "$1" = "clean" ]; then
223         cleanup
224         exit 0
225 fi
226
227 # We need access to CONFIG_ symbols
228 . include/config/auto.conf
229
230 # Update version
231 info GEN .version
232 if [ -r .version ]; then
233         VERSION=$(expr 0$(cat .version) + 1)
234         echo $VERSION > .version
235 else
236         rm -f .version
237         echo 1 > .version
238 fi;
239
240 # final build of init/
241 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
242
243 #link vmlinux.o
244 info LD vmlinux.o
245 modpost_link vmlinux.o
246
247 # modpost vmlinux.o to check for section mismatches
248 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
249
250 info MODINFO modules.builtin.modinfo
251 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
252
253 btf_vmlinux_bin_o=""
254 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
255         if gen_btf .tmp_vmlinux.btf .btf.vmlinux.bin.o ; then
256                 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
257         else
258                 echo >&2 "Failed to generate BTF for vmlinux"
259                 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
260                 exit 1
261         fi
262 fi
263
264 kallsymso=""
265 kallsymso_prev=""
266 kallsyms_vmlinux=""
267 if [ -n "${CONFIG_KALLSYMS}" ]; then
268
269         # kallsyms support
270         # Generate section listing all symbols and add it into vmlinux
271         # It's a three step process:
272         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
273         #     but __kallsyms is empty.
274         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
275         #     the right size
276         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
277         #     the right size, but due to the added section, some
278         #     addresses have shifted.
279         #     From here, we generate a correct .tmp_kallsyms2.o
280         # 3)  That link may have expanded the kernel image enough that
281         #     more linker branch stubs / trampolines had to be added, which
282         #     introduces new names, which further expands kallsyms. Do another
283         #     pass if that is the case. In theory it's possible this results
284         #     in even more stubs, but unlikely.
285         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
286         #     other bugs.
287         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
288         #
289         # a)  Verify that the System.map from vmlinux matches the map from
290         #     ${kallsymso}.
291
292         kallsyms_step 1
293         kallsyms_step 2
294
295         # step 3
296         size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
297         size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
298
299         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
300                 kallsyms_step 3
301         fi
302 fi
303
304 vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
305
306 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
307         info SORTEX vmlinux
308         sortextable vmlinux
309 fi
310
311 info SYSMAP System.map
312 mksysmap vmlinux System.map
313
314 # step a (see comment above)
315 if [ -n "${CONFIG_KALLSYMS}" ]; then
316         mksysmap ${kallsyms_vmlinux} .tmp_System.map
317
318         if ! cmp -s System.map .tmp_System.map; then
319                 echo >&2 Inconsistent kallsyms data
320                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
321                 exit 1
322         fi
323 fi